unit hiGL_ClipPlane;

interface

uses Kol,Share,Debug,OpenGL;

type
  THIGL_ClipPlane = class(TDebug)
   private   
   public
   _prop_Index:Integer;
   _prop_X:Integer;
   _prop_Y:Integer;
   _prop_Z:Integer;
   _prop_D:real;

   _data_Index:THI_Event;
   _data_X:THI_Event;
   _data_Y:THI_Event;
   _data_Z:THI_Event;
   _data_D:THI_Event;
   _event_onEvent:THI_Event;
   _event_onClipPlane:THI_Event;
   
    procedure _work_doEnabled(var _Data:TData; Index:word);
    procedure _work_doDisabled(var _Data:TData; Index:word);
    procedure _work_doClipPlane(var _Data:TData; Index:word);
    procedure _var_Enabled(var _Data:TData; Index:word);
    procedure _var_Max(var _Data:TData; Index:word);             
  end;

implementation
procedure THIGL_ClipPlane._work_doEnabled;
begin
     glEnable (GL_CLIP_PLANE0);
    _hi_CreateEvent(_Data,@_event_onEvent);
end;

procedure THIGL_ClipPlane._work_doDisabled;
begin
    glDisable(GL_CLIP_PLANE0);
    _hi_CreateEvent(_Data,@_event_onEvent);
end;

procedure THIGL_ClipPlane._work_doClipPlane;
var eqr: array [0..3] of Double;
begin
    eqr[0] := ReadInteger(_data,_data_X,_prop_X);
    eqr[1] := ReadInteger(_data,_data_Y,_prop_Y);
    eqr[2] := ReadInteger(_data,_data_Z,_prop_Z);
    eqr[3] := ReadReal(_data,_data_D,_prop_D);
    glClipPlane(GL_CLIP_PLANE0,@eqr);
   _hi_CreateEvent(_Data,@_event_onClipPlane);
end;

procedure THIGL_ClipPlane._var_Enabled;
begin
    dtInteger(_Data,integer(glIsEnabled(GL_Clip_Plane0)));
end;

procedure THIGL_ClipPlane._var_Max(var _Data:TData; Index:word);
var wrk:glint;
begin
  glGetintegerv (GL_MAX_Clip_Planes, @wrk);
  _Data := _DoData(wrk);
end;

end.
